!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Module ChemCalc
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: chemcalc.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview
!
!شϢν̤׻뤿Υ⥸塼. 
!
!Antoine ˰¾Ѥưʲ. 
!  * ˰¾
!  * ˰¾βʬ
!  * Ǯ
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!

module ChemCalc
  !
  !شϢν̤׻뤿Υ⥸塼. 
  !
  
  !ۤηػ
  implicit none

  !ΤФ private °դ. 
  private
  
  !Τˤ public °դ
  public ChemCalc_Init                            !롼
  public ChemCalcSpc_Init, ChemCalcDim_Init       !롼
  public CheckSvapPress                           !˰¾å롼
  public MolWt                                    !ʬ
  public GasR                                     !
  public Phase                                    !
  public ChemPotRef, ChemPot, ChemPotNH4SH  
                                                  !إݥƥ󥷥
  public EntropyRef, Entropy, EntropyNH4SH  
                                                  !إݥƥ󥷥
  public CpPerMassRef, CpPerMolRef, CvPerMassRef  !갵Ǯ, Ǯ
  public xz_SvapPress, SvapPress
                                                  !˰¾ [Pa]
  public xz_SvapPressAMP, SvapPressAMP
                                                  !˰¾ [Pa]
  public xz_DSvapPressDTemp, DSvapPressDTemp 
                                                  !˰¾βʬ [Pa/K]
  public xz_LatentHeatPerMass, LatentHeatPerMass
                                                  !Ǯ [J/K kg]
  public xz_LatentHeatPerMassAMP, LatentHeatPerMassAMP
                                                  !Ǯ [J/K kg]
  public xz_LatentHeatPerMol, LatentHeatPerMol
                                                  !Ǯ [J/K mol]
  public xz_LatentHeatPerMolAMP, LatentHeatPerMolAMP
                                                  !Ǯ [J/K mol]
  public ReactHeatNH4SHPerMass, ReactHeatNH4SHPerMol
                                                  !NH4SH ȿǮ

  real(8)             :: ReactHeatNH4SHPerMass    !NH4SH ȿǮ [J/K kg]
  real(8)             :: ReactHeatNH4SHPerMol     !NH4SH ȿǮ [J/K mol]
  integer             :: XMin = 10   !X ɸϰ(). ͤϥߡ
  integer             :: XMax = 10   !X ɸϰ(). ͤϥߡ
  integer             :: ZMin = 10   !Z ɸϰ(). ͤϥߡ
  integer             :: ZMax = 10   !Z ɸϰ(). ͤϥߡ
  integer             :: SpcNum = 1  !ؼο. ͤϥߡ

  integer, allocatable      :: SpcID(:)     !Ϥ˴ޤޤ벽ؼ. Ƚ
  character(3), allocatable :: Phase(:)     !
  
  save ReactHeatNH4SHPerMass, ReactHeatNH4SHPerMol
  save XMin, XMax, ZMin, ZMax, SpcNum
  save SpcID, Phase
  
contains
  
!!!
!!! 롼
!!!
!!!==========================================================================
  subroutine ChemCalc_Init(IMin, IMax, KMin, KMax, SNum, SID)
    !
    !롼Υåѡ. 
    !  ChemCalcSpc_init  ChemCalcDim_init ¹
    !

    !⥸塼ƤӽФ
    use ChemData, only: GasRUniv,      &!
      &                 ChemData_SpcID  !ؼ ID 
      
    !ۤηػ
    implicit none

    !ѿ
    integer,intent(in) :: IMin      !X β
    integer,intent(in) :: IMax      !X ξ
    integer,intent(in) :: KMin      !Z β
    integer,intent(in) :: KMax      !Z ξ
    integer,intent(in) :: SNum      !ؼθĿ
    integer,intent(in) :: SID(SNum) !Ϥ¸ߤ벽ؼο
    character(20)      :: Name(1)
    integer            :: dim
    integer            :: id(1)

    !롼 2 ĸƤӽФ
    call ChemCalcSpc_Init(SNum, SID)
    call ChemCalcDim_Init(IMin, IMax, KMin, KMax)


    !NH4SH ȿǮν
    !  NH4SH 1kg ФȿǮˤ.
    dim     = 1
    Name(1) = 'NH4SH-s'
    id      = ChemData_SpcID(dim, Name) 
    
    ReactHeatNH4SHPerMol  = GasRUniv * 10834.0d0
    ReactHeatNH4SHPerMass = GasRUniv * 10834.0d0 / MolWt( id(1) )

  end subroutine ChemCalc_Init


!!!==========================================================================
  subroutine ChemCalcSpc_Init(SNum, SID)
    !
    !롼( 1). 
    !  Ѥ벽ؼγ, 줾ʪͤꤹ.
    !  ׻򤷤ʤˤ, ν򤹤нʬǤ. 
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_Phase    !

    !ۤηػ
    implicit none

    !ѿ
    integer,intent(in) :: SNum            !ؼθĿ
    integer,intent(in) :: SID(SNum)       !Ϥ¸ߤ벽ؼο
    
    !ѿ
    integer            :: s

    !-----------------------------------------------------------
    ! 
    !-----------------------------------------------------------
    SpcNum  = SNum
!    write(*,*) "ChemCalc: SpcNum ", SpcNum
    
    !
    if (allocated(SpcID)) deallocate( SpcID, Phase )
    allocate( SpcID(SpcNum), Phase(SpcNum) )

    !-----------------------------------------------------------    
    ! ǡ١ɬפʥǡФ
    !-----------------------------------------------------------
    !Ϥ¸ߤ벽ؼ. Ϥ줿ͤ
    SpcID = SID
    
    !
    do s = 1, SpcNum
      Phase(s) = ChemData_Phase(SpcID(s)) 
    end do
    
  end subroutine ChemCalcSpc_Init


!!!==========================================================================
  subroutine ChemCalcDim_Init(IMin, IMax, KMin, KMax)
    !
    !롼( 2)
    !  󥵥γԤ. ؿѤˤ, 
    !  Υ֥롼ǽɬפ. 
    !   ChemCalcSpc_init ¹ԤƤɬפ. 
    !

    !ۤηػ
    implicit none

    !ѿ
    integer,intent(in) :: IMin  !X β
    integer,intent(in) :: IMax  !X ξ
    integer,intent(in) :: KMin  !Z β
    integer,intent(in) :: KMax  !Z ξ
    
    !-----------------------------------------------------------
    ! 
    !-----------------------------------------------------------
    XMin = IMin;    XMax = IMax
    ZMin = KMin;    ZMax = KMax
    
  end subroutine ChemCalcDim_Init


!!!
!!! ˰¾, Ǯ, etc. δܴؿ. 
!!! ؼ ID Ȳ٤Ф֤ͤ
!!!  

!!!==========================================================================
  function EntropyNH4SH(ID_NH3, ID_H2S, Temp)
    !
    !NH4SH ɸಽإݥƥ󥷥׻. 
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: PressRef,            &!వ
      &                 GasRUniv              !
      
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: EntropyNH4SH       !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    integer, intent(in) :: ID_NH3             !˥ ID
    integer, intent(in) :: ID_H2S             !βǤ ID

    EntropyNH4SH = 0.0d0
    EntropyNH4SH = &
      &   EntropyRef(ID_NH3, Temp) &
      & + EntropyRef(ID_H2S, Temp) &
      & - GasRUniv * 61.781d0            &
      & + GasRUniv * dlog( PressRef * PressRef * 1.0d2) 

  end function EntropyNH4SH


!!!==========================================================================
  function EntropyRef(OneSpcID, Temp)
    !
    !Ϳ줿ؼФ, ɸಽإݥƥ󥷥׻.
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: ChemData_CpPerMolRef,&!ɸ֤Ǥñ̥Ǯ
      &                 ChemData_Entropy,    &!ɸ֤ǤΥȥԡ
      &                 TempRef               !ಹ
      
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: EntropyRef         !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    integer, intent(in) :: OneSpcID           !ؼ ID
    real(8)             :: CpPerMol           !Ǯ 
    real(8)             :: Entropy            !ȥԡ
    real(8)             :: sign               !ʬΤ
    
    !ǡ١
    CpPerMol = ChemData_CpPerMolRef(OneSpcID)
    Entropy  = ChemData_Entropy(OneSpcID)
    
    EntropyRef = 0.0d0
    sign = 1.0d0
    if (Temp < TempRef) sign = -1.0d0

    EntropyRef =                &
      &   Temp * Entropy              &
      & + sign * CpPerMol * dlog( (Temp / TempRef) ** sign )
    
  end function EntropyRef


!!!==========================================================================
  function Entropy(OneSpcID, Temp, PPress)
    !
    !Ϳ줿ؼФ, إݥƥ󥷥׻.
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: PressRef,           & !వ
      &                 GasRUniv              !
    
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: Entropy            !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    real(8), intent(in) :: PPress             !
    integer, intent(in) :: OneSpcID           !ؼ ID
    
    Entropy = 0.0d0
    
    Entropy = &
      & EntropyRef(OneSpcID, Temp) - GasRUniv * dlog(PPress / PressRef)
    
  end function Entropy
  

!!!==========================================================================
  function ChemPotNH4SH(ID_NH3, ID_H2S, Temp)
    !
    !NH4SH ɸಽإݥƥ󥷥׻. 
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: PressRef,            &!వ
      &                 GasRUniv              !
      
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: ChemPotNH4SH       !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    integer, intent(in) :: ID_NH3             !˥ ID
    integer, intent(in) :: ID_H2S             !βǤ ID

    ChemPotNH4SH = 0.0d0
    ChemPotNH4SH = &
      &   ChemPotRef(ID_NH3, Temp) &
      & + ChemPotRef(ID_H2S, Temp) &
      & + GasRUniv * Temp * 61.781d0 - GasRUniv * 10834.0d0  &
      & - GasRUniv * Temp * dlog( PressRef * PressRef * 1.0d2) 

  end function ChemPotNH4SH


!!!==========================================================================
  function ChemPotRef(OneSpcID, Temp)
    !
    !Ϳ줿ؼФ, ɸಽإݥƥ󥷥׻.
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: ChemData_CpPerMolRef,&!ɸ֤Ǥñ̥Ǯ
      &                 ChemData_Enthalpy,   &!ɸ֤ǤΥ󥿥ԡ
      &                 ChemData_Entropy,    &!ɸ֤ǤΥȥԡ
      &                 TempRef               !ಹ
      
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: ChemPotRef         !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    integer, intent(in) :: OneSpcID           !ؼ ID
    real(8)             :: CpPerMol           !Ǯ 
    real(8)             :: Enthalpy           !󥿥ԡ
    real(8)             :: Entropy            !ȥԡ
    real(8)             :: sign               !ʬΤ
    
    !ǡ١
    CpPerMol = ChemData_CpPerMolRef(OneSpcID)
    Enthalpy = ChemData_Enthalpy(OneSpcID)
    Entropy  = ChemData_Entropy(OneSpcID)
    
    ChemPotRef = 0.0d0
    sign = 1.0d0
    if (Temp < TempRef) sign = -1.0d0

    ChemPotRef =                &
      &   Enthalpy                    &
      & - Temp * Entropy              &
      & + CpPerMol * (Temp - TempRef) &
      & - sign * CpPerMol * Temp * dlog( (Temp / TempRef) ** sign )
    
  end function ChemPotRef


!!!==========================================================================
  function ChemPot(OneSpcID, Temp, PPress)
    !
    !Ϳ줿ؼФ, إݥƥ󥷥׻.
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: PressRef,           & !వ
      &                 GasRUniv              !
    
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: ChemPot            !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    real(8), intent(in) :: PPress             !ؼʬ
    integer, intent(in) :: OneSpcID           !ؼ ID
    
    ChemPot = 0.0d0
    
    ChemPot = &
      & ChemPotRef(OneSpcID, Temp) &
      & + GasRUniv * Temp * dlog( PPress / PressRef)
    
  end function ChemPot
  

!!!==========================================================================
  function CpPerMassRef(OneSpcID)
    !
    !Ϳ줿ؼФ, ɸ֤Ǥñ̼갵Ǯ׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_CpPerMassRef !ɸ֤Ǥñ̼Ǯ

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: CpPerMassRef       !ɸ֤Ǥñ̼Ǯ
    integer, intent(in) :: OneSpcID           !ؼ ID

    
    !ǡ١
    CpPerMassRef = ChemData_CpPerMassRef(OneSpcID)

  end function CpPerMassRef


!!!==========================================================================
  function CpPerMolRef(OneSpcID)
    !
    !Ϳ줿ؼФ, ɸ֤Ǥñ̼갵Ǯ׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_CpPerMolRef !ɸ֤Ǥñ̼Ǯ

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: CpPerMolRef        !ɸ֤Ǥñ̼Ǯ
    integer, intent(in) :: OneSpcID           !ؼ ID

    
    !ǡ١
    CpPerMolRef = ChemData_CpPerMolRef(OneSpcID)

  end function CpPerMolRef


!!!==========================================================================
  function CvPerMassRef(OneSpcID)
    !
    !Ϳ줿ؼФ, ɸ֤Ǥñ̼갵Ǯ׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_CvPerMassRef !ɸ֤Ǥñ̼Ǯ

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: CvPerMassRef       !ɸ֤Ǥñ̼Ǯ
    integer, intent(in) :: OneSpcID           !ؼ ID

    
    !ǡ١
    CvPerMassRef = ChemData_CvPerMassRef(OneSpcID)

  end function CvPerMassRef


!!!==========================================================================
  function MolWt(OneSpcID)
    !
    !Ϳ줿ؼФ, ʬ̤׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_MolWt   !ʬ

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: MolWt         !ʬ
    integer, intent(in) :: OneSpcID      !ؼ ID

    
    !ǡ١
    MolWt = ChemData_MolWt(OneSpcID)

  end function MolWt


!!!==========================================================================
  function GasR(OneSpcID)
    !
    !Ϳ줿ؼФ, ׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_GasR    ! [J/K kg]

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: GasR          !ʬ
    integer, intent(in) :: OneSpcID      !ؼ ID
    
    
    !ǡ١
    GasR = ChemData_GasR(OneSpcID)

  end function GasR


!!!==========================================================================
  function SvapPress(OneSpcID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: Temp0C,                      & !O٤Ǥβ[K] 
      &                 ChemData_SvapPress_AntoineA, & !Antoine  A 
      &                 ChemData_SvapPress_AntoineB, & !Antoine  B 
      &                 ChemData_SvapPress_AntoineC, & !Antoine  C 
      &                 ChemData_SvapPress_AntoineUnit !ñѴѷ

    !ۤηػ
    implicit none
    
    !ѿ   
    real(8)             :: SvapPress          !˰¾
    integer, intent(in) :: OneSpcID           !ؼ ID
    real(8), intent(in) :: Temp               ! [K]

    !ѿ
    real(8)             :: A, B, C
    real(8)             :: Unit
    real(8)             :: LogSvapPress
    
    !
    SvapPress = 0.0d0
    A = ChemData_SvapPress_AntoineA(OneSpcID)
    B = ChemData_SvapPress_AntoineB(OneSpcID)
    C = ChemData_SvapPress_AntoineC(OneSpcID)
    Unit = ChemData_SvapPress_AntoineUnit(OneSpcID)

    !˰¾п׻
    LogSvapPress = (A - B / (C + Temp - Temp0C)) * dlog(10.0d0) + Unit 

!    write(*,*) 'chemcalc: ', Temp, LogSvapPress 

    !п礭ʤꤹʤ褦ˤ. 
    ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
    LogSvapPress = min(7.0d2, LogSvapPress)
    
    !˰¾׻
    SvapPress =  dexp( LogSvapPress )

!    write(*,*) 'chemcalc: ', SvapPress, LogSvapPress 

  end function SvapPress


!!!==========================================================================
  function SvapPressAMP(OneSpcID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾׻. AMP 
    !

    !⥸塼ƤӽФ
    use ChemData, only:                          &
      &                 ChemData_SvapPress_AMPA, & !AMP  A 
      &                 ChemData_SvapPress_AMPB, & !AMP  B 
      &                 ChemData_SvapPress_AMPC, & !AMP  C 
      &                 ChemData_SvapPress_AMPD, & !AMP  D 
      &                 ChemData_SvapPress_AMPE    !AMP  E 

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: SvapPressAMP          !˰¾
    integer, intent(in) :: OneSpcID              !ؼ ID
    real(8), intent(in) :: Temp                  ! [K]

    !ѿ
    real(8)             :: A, B, C, D, E
    real(8)             :: LogSvapPress
    
    !
    SvapPressAMP = 0.0d0
    A = ChemData_SvapPress_AMPA(OneSpcID)
    B = ChemData_SvapPress_AMPB(OneSpcID)
    C = ChemData_SvapPress_AMPC(OneSpcID)
    D = ChemData_SvapPress_AMPD(OneSpcID)
    E = ChemData_SvapPress_AMPE(OneSpcID)
    
    !˰¾п׻
    LogSvapPress =  A / Temp + B + C * dlog(Temp) + D * Temp &
      &             + E * (temp ** 2) + dlog(1.0d-1) 
    
    !п礭ʤꤹʤ褦ˤ. 
    ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
    LogSvapPress = min(7.0d2, LogSvapPress)

    !˰¾׻
    SvapPressAMP =  dexp( LogSvapPress )
    
  end function SvapPressAMP


!!!==========================================================================
  function DLogSvapPressDTemp(OneSpcID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾ log βʬ׻
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: Temp0C,                      & !O٤Ǥβ[K] 
      &                 ChemData_SvapPress_AntoineB, & !Antoine  B 
      &                 ChemData_SvapPress_AntoineC    !Antoine  C 

    !ۤηػ
    implicit none
  
    !ѿ    
    real(8)             :: DLogSvapPressDTemp!˰¾ log βʬ[Pa/K]
    integer, intent(in) :: OneSpcID          !ؼ ID
    real(8), intent(in) :: Temp              ! [K]
    
    !ѿ
    real(8)             :: B, C
    
    !
    DLogSvapPressDTemp = 0.0d0
    B = ChemData_SvapPress_AntoineB(OneSpcID)
    C = ChemData_SvapPress_AntoineC(OneSpcID)
    
    !˰¾βʬ
    DLogSvapPressDTemp =                                &
      &  B * dlog(10.0d0) / ( (C + Temp - Temp0C) ** 2.0d0 )
    
  end function DLogSvapPressDTemp


!!!==========================================================================
  function DLogSvapPressAMPDTemp(OneSpcID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾ log βʬ׻
    !AMP 
    !
    
    !⥸塼ƤӽФ
    use ChemData, only:                          & !
      &                 ChemData_SvapPress_AMPA, & !Antoine  B 
      &                 ChemData_SvapPress_AMPC, & !Antoine  B 
      &                 ChemData_SvapPress_AMPD, & !Antoine  B 
      &                 ChemData_SvapPress_AMPE    !Antoine  C 
    
    !ۤηػ
    implicit none
  
    !ѿ    
    real(8)             :: DLogSvapPressAMPDTemp 
                                            !˰¾ log βʬ [Pa/K]
    integer, intent(in) :: OneSpcID         !ؼ ID
    real(8), intent(in) :: Temp             ! [K]
    
    !ѿ
    real(8)             :: A, C, D, E
    
    !
    DLogSvapPressAMPDTemp = 0.0d0
    A = ChemData_SvapPress_AMPA(OneSpcID)
    C = ChemData_SvapPress_AMPC(OneSpcID)
    D = ChemData_SvapPress_AMPD(OneSpcID)
    E = ChemData_SvapPress_AMPE(OneSpcID)
    
    !˰¾βʬ
    DLogSvapPressAMPDTemp =                                 &
      & - A / (Temp ** 2.0d0) + C / Temp + D + (2.0d0 * E * Temp)
    
  end function DLogSvapPressAMPDTemp


!!!==========================================================================
  function DSvapPressDTemp(OneSpcID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾βʬ׻
    !
    
    !ۤηػ
    implicit none
  
    !ѿ    
    real(8)             :: DSvapPressDTemp        !˰¾βʬ [Pa/K]
    integer, intent(in) :: OneSpcID               !ؼ̾
    real(8), intent(in) :: Temp                   ! [K]
    
    !
    DSvapPressDTemp = 0.0d0
    
    !˰¾βʬ
    DSvapPressDTemp =                          &
      & SvapPress(OneSpcID, Temp)              &
      & * DLogSvapPressDTemp(OneSpcID, Temp)
    
  end function DSvapPressDTemp


!!!==========================================================================
  function DSvapPressAMPDTemp(OneSpcID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾βʬ׻
    !
    
    !ۤηػ
    implicit none
  
    !ѿ    
    real(8)             :: DSvapPressAMPDTemp  
                                                  !˰¾βʬ [Pa/K]
    integer, intent(in) :: OneSpcID               !ؼ̾
    real(8), intent(in) :: Temp                   ! [K]
    
    !
    DSvapPressAMPDTemp = 0.0d0
    
    !˰¾βʬ
    DSvapPressAMPDTemp =                          &
      & SvapPressAMP(OneSpcID, Temp)              &
      & * DLogSvapPressAMPDTemp(OneSpcID, Temp)
    
  end function DSvapPressAMPDTemp
  

!!!==========================================================================
  function LatentHeatPerMass(OneSpcID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, Ǯ׻
    !

    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: LatentHeatPerMass    !Ǯ
    integer, intent(in) :: OneSpcID            !ؼ̾
    real(8), intent(in) :: Temp                !

    !ѿ
    real(8), parameter  :: GasRUniv = 8.314d0  !׵
    
    !
    LatentHeatPerMass  = 0.0d0
    
    !Ǯη׻
    LatentHeatPerMass =                                                        &
      & DLogSvapPressDTemp(OneSpcID, Temp) * GasRUniv * (Temp ** 2.0d0) &
      & / MolWt(OneSpcID)

  end function LatentHeatPerMass


!!!==========================================================================
  function LatentHeatPerMol(OneSpcID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, Ǯ׻
    !

    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: LatentHeatPerMol    !Ǯ
    integer, intent(in) :: OneSpcID            !ؼ̾
    real(8), intent(in) :: Temp                !

    !ѿ
    real(8), parameter  :: GasRUniv = 8.314d0  !׵
    
    !
    LatentHeatPerMol  = 0.0d0
    
    !Ǯη׻
    LatentHeatPerMol =                                                  &
      & DLogSvapPressDTemp(OneSpcID, Temp) * GasRUniv * (Temp ** 2.0d0) 

  end function LatentHeatPerMol


!!!==========================================================================
  function LatentHeatPerMassAMP(OneSpcID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, Ǯ׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_MolWt         !ʬ

    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: LatentHeatPerMassAMP !Ǯ
    integer, intent(in) :: OneSpcID            !ؼ̾
    real(8), intent(in) :: Temp                !
    
    !ѿ
    real(8), parameter  :: GasRUniv = 8.314d0  !׵
    
    !
    LatentHeatPerMassAMP  = 0.0d0
    
    !Ǯη׻
    LatentHeatPerMassAMP =                           &
      & DLogSvapPressAMPDTemp(OneSpcID, Temp) &
      & * GasRUniv * (Temp ** 2.0d0)                &
      & / ChemData_MolWt(OneSpcID)

  end function LatentHeatPerMassAMP


!!!==========================================================================
  function LatentHeatPerMolAMP(OneSpcID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, Ǯ׻
    !

     !ۤηػ
    implicit none

    !ѿ
    real(8)             :: LatentHeatPerMolAMP !Ǯ
    integer, intent(in) :: OneSpcID            !ؼ̾
    real(8), intent(in) :: Temp                !
    
    !ѿ
    real(8), parameter  :: GasRUniv = 8.314d0  !׵
    
    !
    LatentHeatPerMolAMP  = 0.0d0
    
    !Ǯη׻
    LatentHeatPerMolAMP =                           &
      & DLogSvapPressAMPDTemp(OneSpcID, Temp)       &
      & * GasRUniv * (Temp ** 2.0d0)                

  end function LatentHeatPerMolAMP


!!!
!!! ˰¾å롼
!!!

!!!==========================================================================
  subroutine CheckSvapPress()
    !
    !˰¾Υå֥롼. 
    !¬ͤȷ׻ͤκϤ.
    !

    !⥸塼ɤ߹
    use ChemData, only : ChemData_DataNum,         & !ǡ 
      &                  ChemData_SVapPress,       & !˰¾
      &                  ChemData_SVapPress_Temp     !
    
    !ۤηػ
    implicit none
    
    !ѿ
    integer             :: SNum
    integer             :: DNum
    real(8)             :: SVapPressData(SpcNum, ChemData_DataNum)
    real(8)             :: Temp(SpcNum, ChemData_DataNum)
    real(8)             :: SVapPressCalc

    !ǡ١
    do SNum = 1, SpcNum
      SvapPressData(SNum,:) = ChemData_SvapPress(SpcID(SNum),:) 
      Temp(SNum,:)          = ChemData_SvapPress_Temp(SpcID(SNum),:) 
    end do

    do SNum = 1, SpcNum
      if (Phase(SNum) == 'Gas') cycle   !ξ
      
      write(*,*) "SpcName:      ", SpcID(SNum)
      
      do DNum = 1, ChemData_DataNum
        if ( Temp(SNum,DNum) == 0.0d0) cycle
        SvapPressCalc = SvapPress( SpcID(SNum), Temp(SNum,DNum) )
        
        write(*,*) "Temp:         ", Temp(SNum,DNum)
        write(*,*) "SVapPress:    ", SVapPressData(SNum,DNum), SVapPressCalc
        write(*,*) "DelSVapPress: ", abs(SVapPressData(SNum,DNum) - SVapPressCalc)
      end do
      SVapPressCalc = 0.0d0 !
    end do
    
  end subroutine CheckSvapPress
  


!!!
!!! ܴؿΥåѡ
!!!

!!!==========================================================================
  function xz_SvapPress( OneSpcID, xz_Temp )
    !
    !˰¾η׻. Antoine μ
    !

    !ۤηػ
    implicit none
    
    ! ѿ  
    real(8)             :: xz_SvapPress(XMin:XMax, ZMin:ZMax) 
                                                             !˰¾
    integer, intent(in) :: OneSpcID                          !ؼ ID
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)     !
  
    !ѿ
    integer             :: i, k

    !
    xz_SvapPress = 0.0d0 

    !ܴؿƤӽФȤͤ
    do k = ZMin, ZMax
      do i = XMin, XMax        
        xz_SvapPress(i,k) = SvapPress(OneSpcID, xz_Temp(i,k))

!        write(*,*) 'chemcalc2: ', xz_Temp(i,k), xz_SvapPress(i,k)
      end do
    end do
    
  end function xz_SvapPress


!!!==========================================================================
  function xz_SvapPressAMP( OneSpcID, xz_Temp )
    !
    !˰¾η׻. Antoine μ
    !

    !ۤηػ
    implicit none
    
    ! ѿ  
    real(8)             :: xz_SvapPressAMP(XMin:XMax, ZMin:ZMax) 
                                                             !˰¾
    integer, intent(in) :: OneSpcID                          !ؼ ID
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)     !
  
    !ѿ
    integer             :: i, k

    !
    xz_SvapPressAMP = 0.0d0 

    !ܴؿƤӽФȤͤ
    do k = ZMin, ZMax
      do i = XMin, XMax        
        xz_SvapPressAMP(i,k) = SvapPressAMP(OneSpcID, xz_Temp(i,k))
      end do
    end do
    
  end function xz_SvapPressAMP


!!!==========================================================================
  function xz_DSvapPressDTemp(OneSpcID, xz_Temp)
    !
    !˰¾βʬη׻. Antoine μ
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8)             :: xz_DSvapPressDTemp(XMin:XMax, ZMin:ZMax)
                                                   !˰¾βʬ [Pa/K]
    integer, intent(in) :: OneSpcID                !ؼ ID
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)           
                                                   ! [K]
  
    !ѿ
    integer             :: k, i

    !
    xz_DSvapPressDTemp = 0.0d0

    !ܴؿƤӽФȤͤ
    do k = ZMin, ZMax
      do i = XMin, XMax        
        xz_DSvapPressDTemp(i,k) = DSvapPressDTemp(OneSpcID, xz_Temp(i,k))
      end do
    end do
    
  end function xz_DSvapPressDTemp


!!!==========================================================================
  function xz_DLogSvapPressDTemp(OneSpcID, xz_Temp)
    !
    !˰¾ log βʬη׻. Antoine μ
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8)           :: xz_DLogSvapPressDTemp(XMin:XMax, ZMin:ZMax)
                                           !˰¾ log βʬ [Pa/K]
    integer, intent(in) :: OneSpcID        !ؼ ID
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)
                                           ! [K]
  
    !ѿ
    integer             :: k, i

    !
    xz_DLogSvapPressDTemp = 0.0d0

    !ܴؿƤӽФȤͤ
    do k = ZMin, ZMax
      do i = XMin, XMax        
        xz_DLogSvapPressDTemp(i,k) = &
          & DLogSvapPressDTemp(OneSpcID, xz_Temp(i,k))
      end do
    end do
    
  end function xz_DLogSvapPressDTemp


!!!==========================================================================
  function xz_LatentHeatPerMass(OneSpcID, xz_Temp)
    !
    !˰¾Ǯ׻. Antoine μ
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: xz_LatentHeatPerMass(XMin:XMax, ZMin:ZMax)
                                                            !Ǯ[J/K kg]
    integer, intent(in) :: OneSpcID                         !ؼ ID
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)    ![K]

    !ؿ
    integer             :: i, k

    !
    xz_LatentHeatPerMass = 0.0d0

    !ܴؿƤӽФȤͤ
    do k = ZMin, ZMax
      do i = XMin, XMax        
        xz_LatentHeatPerMass(i,k) = LatentHeatPerMass(OneSpcID, xz_Temp(i,k))
      end do
    end do

  end function xz_LatentHeatPerMass


!!!==========================================================================
  function xz_LatentHeatPerMol(OneSpcID, xz_Temp)
    !
    !˰¾Ǯ׻. Antoine μ
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: xz_LatentHeatPerMol(XMin:XMax, ZMin:ZMax)
                                                            !Ǯ[J/K kg]
    integer, intent(in) :: OneSpcID                         !ؼ ID
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)    ![K]

    !ؿ
    integer             :: i, k

    !
    xz_LatentHeatPerMol = 0.0d0

    !ܴؿƤӽФȤͤ
    do k = ZMin, ZMax
      do i = XMin, XMax        
        xz_LatentHeatPerMol(i,k) = LatentHeatPerMol(OneSpcID, xz_Temp(i,k))
      end do
    end do

  end function xz_LatentHeatPerMol


!!!==========================================================================
  function xz_LatentHeatPerMassAMP(OneSpcID, xz_Temp)
    !
    !˰¾Ǯ׻. Antoine μ
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: xz_LatentHeatPerMassAMP(XMin:XMax, ZMin:ZMax)
                                                            !Ǯ[J/K kg]
    integer, intent(in) :: OneSpcID                         !ؼ ID
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)    ![K]

    !ؿ
    integer             :: i, k

    !
    xz_LatentHeatPerMassAMP = 0.0d0

    !ܴؿƤӽФȤͤ
    do k = ZMin, ZMax
      do i = XMin, XMax        
        xz_LatentHeatPerMassAMP(i,k) = LatentHeatPerMassAMP(OneSpcID, xz_Temp(i,k))
      end do
    end do

  end function xz_LatentHeatPerMassAMP


!!!==========================================================================
  function xz_LatentHeatPerMolAMP(OneSpcID, xz_Temp)
    !
    !˰¾Ǯ׻. Antoine μ
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: xz_LatentHeatPerMolAMP(XMin:XMax, ZMin:ZMax)
                                                            !Ǯ[J/K kg]
    integer, intent(in) :: OneSpcID                         !ؼ ID
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)    ![K]

    !ؿ
    integer             :: i, k

    !
    xz_LatentHeatPerMolAMP = 0.0d0

    !ܴؿƤӽФȤͤ
    do k = ZMin, ZMax
      do i = XMin, XMax        
        xz_LatentHeatPerMolAMP(i,k) = LatentHeatPerMolAMP(OneSpcID, xz_Temp(i,k))
      end do
    end do

  end function xz_LatentHeatPerMolAMP



end module ChemCalc

