!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Subroutine DisturbEnv
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: disturbenv.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $ 
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview 
!
!ǥեȤξͿ뤿Υ롼. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!  * ǽʾΥפ䤹
!  * 顼 gf4f90io 
!

subroutine DisturbEnv( cfgfile,         &
  & pz_VelX,     xr_VelZ,               &
  & xz_Exner,    xz_PotTemp,   xz_MixRt )
  !
  !ǥեȤξͿ뤿Υ롼. 
  !
  
  !⥸塼ɤ߹
  use gridset,    only:DimXMin,         &!  X β
    &                  DimXMax,         &!  X ξ
    &                  DimZMin,         &!  Z β
    &                  DimZMax,         &!  Z ξ
    &                  RegZMin,         &! ʪΰ Z β
    &                  SpcNum,          &! Žؼο
    &                  XMin, XMax,      &! 
    &                  ZMin, ZMax,      &! 
    &                  s_X,             &! X ɸ(顼ʻ)
    &                  s_Z               ! Z ɸ(顼ʻ)
  use fileset,    only:RandomFile        ! ե
  use basicset,   only:                  &
    &                  SpcWetMolFr,     &!Žʬν
    &                  MolWtWet,        &!Žʬʬ
    &                  xz_TempBasicZ,   &! ܾβ
    &                  xz_PressBasicZ,  &! ܾΰ
    &                  xz_MixRtBasicZ    ! ܾκ
  use Boundary, only:  xz_Boundary_Cyc_Sym 
  use MoistFunc,only:  xz_MolFr2MixRt
  use ECCM,     only:  ECCM_MolFr


  !ۤηػ
  implicit none
  
  !ѿ
  character(*), intent(in) :: cfgfile
  real(8), intent(out)  :: pz_VelX(DimXMin:DimXMax,DimZMin:DimZMax)  
                                    !ʿ®ξʬ
  real(8), intent(out)  :: xr_VelZ(DimXMin:DimXMax,DimZMin:DimZMax) 
                                    !ľ®ξʬ 
  real(8), intent(out)  :: xz_Exner(DimXMin:DimXMax,DimZMin:DimZMax)  
                                    !ʡؿξʬ 
  real(8), intent(out)  :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)  
                                    !̤ξʬ 
  real(8), intent(out)  :: xz_MixRt(DimXMin:DimXMax,DimZMin:DimZMax, SpcNum)  
                                    !Žʬκ(ʬ)
  real(8), parameter         :: Pi = 3.1415926535897932385d0 
                                    !߼Ψ
  integer       :: i, k, s
  real(8)       :: Humidity         !м
  real(8)       :: XcRate           !濴(ʿ)ΰФ
  real(8)       :: XrRate           !Ⱦ(ʿ)ΰФ
  real(8)       :: ZcRate           !濴(ľ)ΰФ
  real(8)       :: ZrRate           !Ⱦ(ľ)ΰФ
  real(8)       :: Xc               !濴(ʿ)
  real(8)       :: Xr               !Ⱦ(ʿ)
  real(8)       :: Zc               !濴(ľ)
  real(8)       :: Zr               !Ⱦ(ľ)
  real(8)       :: beta(DimXMin:DimXMax, DimZMin:DimZMax)
                                    !κͤФ
  real(8)       :: DelMax           !̾κ
  real(8)       :: Random           !ե뤫
  character(20) :: Type             !̾Υ
  real(8)       :: xz_MolFr(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                    !

  !-------------------------------------------------------------
  ! 
  !-------------------------------------------------------------
  !NAMELIST եɤ߹
  NAMELIST /disturbset/ &
    & Type, DelMax, XrRate, XcRate, ZrRate, ZcRate, &
    & Humidity

  open (10, FILE=cfgfile)
  read(10, NML=disturbset)
  close(10)
  
  !
  pz_VelX = 0.0d0
  xr_VelZ = 0.0d0
  xz_Exner = 0.0d0
  xz_PotTemp = 0.0d0
  xz_MixRt   = 0.0d0

  !-------------------------------------------------------------
  ! ̤ξ
  !-------------------------------------------------------------
  select case(Type)

  case ("Thermal")
    ! ꤵ줿˲̤ 1 ĤǮŪޥͿ. 
    
    Xr = (XMax - XMin) * XrRate
    Xc = (XMax - XMin) * XcRate
    Zr = (ZMax - ZMin) * ZrRate
    Zc = (ZMax - ZMin) * ZcRate
    
    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        beta(i,k) =                                 &
          & (                                       &
          &      ( ( s_X(i) - Xc ) / Xr ) ** 2.0d0  &
          &    + ( ( s_Z(k) - Zc ) / Zr ) ** 2.0d0  &
          &  ) ** 5.0d-1
      end do
    end do
    
    where ( beta < 1.0d0 )
      xz_PotTemp = DelMax * ( dcos( Pi * 5.0d-1 * beta ) ** 2.0d0 )
    end where


  case ("Thermal-Gauss")
    ! ꤵ줿, ʲ̤ξͿ. 

    Xr = (XMax - XMin) * XrRate
    Xc = (XMax - XMin) * XcRate
    Zr = (ZMax - ZMin) * ZrRate
    Zc = (ZMax - ZMin) * ZcRate
    
    do i = DimXMin, DimXMax
      xz_PotTemp(i,:) = &
        & DelMax * dexp( - ( (s_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1 ) 
    end do
    
    do k = DimZMin, DimZMax
      xz_PotTemp(:,k) =  &
        & xz_PotTemp(:,k) * dexp( - ( (s_Z(k) - Zc) / Zr )**2.0d0 * 5.0d-1 ) 
    end do
    
    where ( xz_PotTemp < DelMax * 1.0d-4)
      xz_PotTemp = 0.0d0 
    end where
    
  case ("Exner-Gauss")
    ! ꤵ줿, ʲ̤ξͿ. 

    Xr = (XMax - XMin) * XrRate
    Xc = (XMax - XMin) * XcRate
    Zr = (ZMax - ZMin) * ZrRate
    Zc = (ZMax - ZMin) * ZcRate
    
    do i = DimXMin, DimXMax
      xz_Exner(i,:) = &
        & DelMax * dexp( - ( (s_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1 ) 
    end do
    
    do k = DimZMin, DimZMax
      xz_Exner(:,k) =  &
        & xz_Exner(:,k) * dexp( - ( (s_Z(k) - Zc) / Zr )**2.0d0 * 5.0d-1 ) 
    end do
    
    where ( xz_Exner < DelMax * 1.0d-4)
      xz_Exner = 0.0d0 
    end where
    
  case ("Thermal-Random")
    ! ǲؤ˥ʾͿ

    open(20,file=RandomFile)
    do i = DimXMin, DimXMax
      read(20,*) random
      xz_Exner(i, RegZMin+1) = DelMax * random
    end do
    close(20)
    
  end select

  
  !-------------------------------------------------------------
  ! . 
  !-------------------------------------------------------------
  do i = DimXMin, DimXMax      
    call ECCM_MolFr( SpcWetMolFr(1:SpcNum), Humidity, xz_TempBasicZ(i,:), &
      &              xz_PressBasicZ(i,:), xz_MolFr(i,:,:) )
  end do
    
  !Υ򺮹Ѵ
  do s = 1, SpcNum
    xz_MixRt(:,:,s) = xz_MolFr2MixRt(MolWtWet(s), xz_MolFr(:,:,s)) - xz_MixRtBasicZ(:,:,s)
  end do

  !ͤʤꤹʤ褦˺ͤͿ
!  where (xz_MixRt <= 1.0d-20 )
!    xz_MixRt = 1.0d-20
!  end where
  
  !
  do s = 1, SpcNum
    xz_MixRt(:,:,s) = xz_Boundary_Cyc_Sym(xz_MixRt(:,:,s))
  end do

end subroutine DisturbEnv
