!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Program Arare
!
!   * Developer: SUGIYAMA Ko-ichiro 
!   * Version: $ 
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview 
!
!ϳإǥ deepconv/arare. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ϤϽవ̷.
!
!== Future Plans
!

program arare
  !
  !ϳإǥ deepconv/arare. 
  !

  !⥸塼ɤ߹
  use chemcalc

  use fileset
  use debugset
  use timeset
  use gridset
  use basicset

  use damping
  use timefilter
  use boundary
  use cflcheck

!  use RestartFileIO
  use HistoryFileIO

  use DynFunc
  use DynImpFunc

  use NumDiffusion
  use Turbulence

  use MoistAdjust
  use WarmRainPrm 
  use MoistBuoyancy

  !ۤηػ
  implicit none

  !ѿ
  character(80) :: cfgfile
  real(8), allocatable :: pz_VelXBl(:,:)
  real(8), allocatable :: pz_VelXNl(:,:)
  real(8), allocatable :: pz_VelXAl(:,:)
  real(8), allocatable :: pz_VelXNs(:,:)
  real(8), allocatable :: pz_VelXAs(:,:)
  real(8), allocatable :: xr_VelZBl(:,:)
  real(8), allocatable :: xr_VelZNl(:,:)
  real(8), allocatable :: xr_VelZAl(:,:)
  real(8), allocatable :: xr_VelZNs(:,:)
  real(8), allocatable :: xr_VelZAs(:,:)
  real(8), allocatable :: xz_ExnerBl(:,:)
  real(8), allocatable :: xz_ExnerNl(:,:)
  real(8), allocatable :: xz_ExnerAl(:,:)
  real(8), allocatable :: xz_ExnerNs(:,:)
  real(8), allocatable :: xz_ExnerAs(:,:)
  real(8), allocatable :: xz_PotTempBl(:,:)
  real(8), allocatable :: xz_PotTempNl(:,:)
  real(8), allocatable :: xz_PotTempAl(:,:)
  real(8), allocatable :: xz_KmBl(:,:)
  real(8), allocatable :: xz_KmNl(:,:)
  real(8), allocatable :: xz_KmAl(:,:)
  real(8), allocatable :: xz_KhBl(:,:)
  real(8), allocatable :: xz_KhNl(:,:)
  real(8), allocatable :: xz_KhAl(:,:)
  real(8), allocatable :: xz_MixRtBl(:,:,:)
  real(8), allocatable :: xz_MixRtNl(:,:,:)
  real(8), allocatable :: xz_MixRtAl(:,:,:)

  real(8), allocatable :: pz_AccelVelXNl(:,:)
  real(8), allocatable :: xr_AccelVelZNl(:,:)

  real(8)              :: Time
  real(8)              :: ReStartTime(2)
  real(8), allocatable :: DelTimeLFrog(:)
  real(8)              :: DelTimeEular
  integer, allocatable :: NStepEular(:)
  integer              :: NStepLFrog

  integer              :: t, tau
  integer              :: spc

 
  !----------------------------------------------------------------------
  ! ѿȷ⥸塼ν
  !----------------------------------------------------------------------
  !NAMELIST եμ
  call getarg( 1, cfgfile )
  write(*,*) "Input NAMELIST file: ", cfgfile
  
  !I/O ե̾ν
  !  NAMELIST ե̾ꤷ, deepconv/arare 
  !  ϥե̾ NAMELIST 
  call fileset_init(cfgfile)
  
  !ǥХν
  !  NAMELIST , ǥХåϥåؤԤ.  
  call debugset_init(cfgfile)
  
  !˴ؤν
  !  NAMELIST ɬפʾɤ߼, ִϢѿԤ. 
  call timeset_init(cfgfile)

  !ʻν
  !  NAMELIST , ʻ׻
  call gridset_init(cfgfile)
  
  !ܾξν
  !  NAMELIST , ܾꤹ.
  call basicset_init(cfgfile)
  
  !ѿν. ȤꤢͤꤵƤ. 
  call ArareAlloc
  
  !ͽѿν
  !  ReStartFile ꤵƤˤϥեɤ߹, 
  !  ꤵƤʤˤ, ǥեȤδܾȾ. 
!  if (InitFile /= '') then    
!    !ꥹȥեɤ߹
!    call basicset_file_init(InitFile)
!
!    !νͤ netCDF ե뤫.
!    call ReStartFile_Get(                        &
!      & ReStartTime,                             &
!      & pz_VelXBl,     xr_VelZBl,  xz_ExnerBl,   &
!      & xz_PotTempBl,  xz_KmBl,    xz_MixRtBl,   &
!      & pz_VelXNl,     xr_VelZNl,  xz_ExnerNl,   &
!      & xz_PotTempNl,  xz_KmNl,    xz_MixRtNl  )    
!  else
    !ǥեδܾ, . 
    call BasicEnv()
    call DisturbEnv(cfgfile,                      &
      & pz_VelXBl,   xr_VelZBl,                   &
      & xz_ExnerBl,  xz_PotTempBl,                &
      & xz_MixRtBl )
!  end if
  
  
  !----------------------------------------------------------------------
  ! ѥå⥸塼ν
  !   ǥեȤͤѹɬפΤ롼Τ߽
  !----------------------------------------------------------------------
  call Damping_Init( cfgfile )      !Ȥθ그ν
  call DynImpFunc_Init()            !ˡν
  call NumDiffusion_Init()          !ͳȻν
  call Turbulence_Init()            !ή׻ν
  call MoistAdjust_Init()           !˰Ĵˡν
  call WarmRainPrm_Init()           !ȤΥѥ᥿ꥼν
  call MoistBuoy_Init()             !ʬ̤ФϷ׻롼ν

  !----------------------------------------------------------------------
  ! ȥ롼ײν 
  !----------------------------------------------------------------------
!  if (InitFile /= '') then    
!    Time = ReStartTime(2)               !ꥹȳϻ
!    NstepLFrog   = NstepLong - 1
!    NstepEular   = NstepShort 
!    DelTimeLFrog = DelTimeLong * 2.0d0 
!    DelTimeEular = DelTimeShort
!  else
    Time = 0.0d0                          !׻ϻ
    NstepLFrog      = NstepLong
    NstepEular      = NstepShort 
    NstepEular(1)   = NstepShort * 5.0d-1 ! 1 롼ܤ
    DelTimeLFrog    = DelTimeLong * 2.0d0     
    DelTimeLFrog(1) = DelTimeLong         ! 1 롼ܤ
    DelTimeEular    = DelTimeShort
    
    ! 1 롼ܤ, bl  nl ͤƱˤƤ. 
    ! 1 ƥåܤϥ顼ˡǲɬפ뤬, 
    ! 1 ƥåܤȤʳΥƥåפ̡˥ǥ󥰤ʤ
    pz_VelXNl    = pz_VelXBl
    xr_VelZNl    = xr_VelZBl
    xz_ExnerNl   = xz_ExnerBl
    xz_PotTempNl = xz_PotTempBl
    xz_KmNl      = xz_KmBl
    xz_KhNl      = xz_KhBl
    xz_MixRtNl   = xz_MixRtBl
!  end if
  
  !----------------------------------------------------------------
  ! ե
  !----------------------------------------------------------------
  !ե륪ץ
  call HistoryFile_Open( )

!  if (InitFile /= '') then    
!    call HistoryFile_Output( ReStartTime(1),           &
!      &  xz_CNcrNl, xz_CLcrNl, xz_EVrvNl, xz_PRrNl,&
!      &  pz_VelXBl,    xr_VelZBl,   xz_ExnerBl,  &
!      &  xz_PotTempBl, xz_KmBl,     xz_MixRtBl  )
!
!    call HistoryFile_Output( ReStartTime(2),           &
!      &  xz_CNcrNl, xz_CLcrNl, xz_EVrvNl, xz_PRrNl,&
!      &  pz_VelXNl,    xr_VelZNl,   xz_ExnerNl,  &
!      &  xz_PotTempNl, xz_KmNl,     xz_MixRtNl  )
!  end if

  ! 0 ξˤϽ
  if ( Time == 0 ) then
    call HistoryFile_Output(  &
      &  Time,                &
      &  xz_PotTempNl,        &
      &  xz_ExnerNl,          &
      &  pz_VelXNl,           &
      &  xr_VelZNl,           &
      &  xz_MixRtNl,          &
      &  xz_KmNl              )
    call HistoryFile_OutputAnal(  &
      &  xz_PotTempNl,            &
      &  xz_ExnerNl,              &
      &  xz_MixRtNl               )
  end if
  
  !----------------------------------------------------------------------
  ! Υå
  !----------------------------------------------------------------------
  !CFL Υå
  call CFLCheckTimeShort( xz_VelSoundBasicZ )

  !----------------------------------------------------------------------
  ! ʬ
  !----------------------------------------------------------------------
  LFrog: do t = 1, NstepLFrog

    !
    Time = Time + DelTimeLong
    write(*,*) Time

    !----------------------------------------------------------------
    ! Ǵ, Ȼ.
    !----------------------------------------------------------------
    xz_KmAl =                                                      &
      & xz_KmBl                                                    &
      & + DelTimeLFrog(t)                                          &
      &   * (                                                      &
      &     + xz_AdvScalar(xz_KmNl, pz_VelXNl, xr_VelZNl)           &
      &     + xz_BuoyKm(xz_PotTempBl)                               &
!      &     + xz_MoistBuoyKm(xz_ExnerBl, xz_PotTempBl, xz_MixRtBl) &
      &     + xz_ShearKm(xz_KmBl, pz_VelXBl, xr_VelZBl)             &   
      &     + xz_NumDiffScalar(xz_KmBl)                             &
      &     + xz_DispKm(xz_KmBl)                                   &
      &    )
    
    !ν
    where (xz_KmAl < 0.0d0)
      xz_KmAl = 0.0d0
    end where
   
    !ͤξ (, 1994, ذʸ)
    where (xz_KmAl > 800.0d0)
     xz_KmAl = 800.0d0
    end where

    !
    xz_KmAl = xz_Boundary_Cyc_Sym(xz_KmAl)
   
    !åλ֥ե륿. Nl ͤե륿
    xz_KmNl = AsselinFilter(xz_KmAl, xz_KmNl, xz_KmBl)
  
    !Ȼ
    xz_KhAl = 3.0d0 * xz_KmAl

    
    !----------------------------------------------------------------
    ! ̤ΰή׻.
    !----------------------------------------------------------------
    xz_PotTempAl =                                                &
      &   xz_PotTempBl                                            &
      & + DelTimeLFrog(t)                                         &
      &   * (                                                     &
      &     + xz_AdvScalar( xz_PotTempNl, pz_VelXNl, xr_VelZNl)    &
      &     + xz_TurbScalar(xz_PotTempBl, xz_KhBl)                 &
      &     + xz_NumDiffScalar(xz_PotTempBl)                       &
      &     + xz_AdvScalar( xz_PotTempBasicZ, pz_VelXNl, xr_VelZNl)&
      &     + xz_TurbScalar(xz_PotTempBasicZ, xz_KhBl)             &
      &     + xz_DispQ( xz_KmBl )                                 &
!      &     + xz_RadiQ( xz_ExnerBl )                              &
!      &     + xz_HFluxSfc(pz_VelXBl, xz_PotTempBl, xz_ExnerBl)    &
      &      )
    
    !
    xz_PotTempAl = xz_Boundary_Cyc_Sym( xz_PotTempAl )
    
    !åλ֥ե륿. Nl ͤե륿
    xz_PotTempNl = AsselinFilter(xz_PotTempAl, xz_PotTempNl, xz_PotTempBl)

    
    !----------------------------------------------------------------
    ! Žʬκΰή׻.
    !----------------------------------------------------------------
    do spc = 1, SpcNum
      !ʬ
      xz_MixRtAl(:,:,spc) =                                               & 
        &   xz_MixRtBl(:,:,spc)                                           &
        & + DelTimeLFrog(t)                                               &
        &   * (                                                           &
        &    + xz_AdvScalar(xz_MixRtNl(:,:,spc), pz_VelXNl, xr_VelZNl)    &
        &    + xz_TurbScalar(xz_MixRtBl(:,:,spc), xz_KhBl)                &
        &    + xz_NumDiffScalar(xz_MixRtBl(:,:,spc))                      &
        &    + xz_AdvScalar(xz_MixRtBasicZ(:,:,spc), xr_VelZNl, xr_VelZNl)& 
        &    + xz_TurbScalar(xz_MixRtBasicZ(:,:,spc), xz_KhBl)            &
        &    + xz_FallRain(xz_MixRtBl(:,:,spc), spc)                      &
        &    )
      !
      xz_MixRtAl(:,:,spc) = xz_Boundary_Cyc_Sym(xz_MixRtAl(:,:,spc))
      
      !åλ֥ե륿. Nl ͤե륿
      xz_MixRtNl(:,:,spc) &
        & = AsselinFilter(xz_MixRtAl(:,:,spc), xz_MixRtNl(:,:,spc), xz_MixRtBl(:,:,spc))

      !ήˤäˤʤäʬ
      call FillNegative( xz_DensBasicZ, xz_MixRtAl(:,:,spc) )
      xz_MixRtAl(:,:,spc) = xz_Boundary_Cyc_Sym(xz_MixRtAl(:,:,spc))
      
    end do
    
    
    !-------------------------------------------------------------
    ! ȤΥѥ᥿ꥼ.
    !   <--> ѴԤ
    !-------------------------------------------------------------
    xz_MixRtAl(:,:,:) =                                 & 
     &   xz_MixRtAl(:,:,:)                             &
      & + DelTimeLFrog(t)                               &
      &   * (                                           &
      &       + xz_Cloud2Rain( xz_MixRtAl(:,:,:) )      &
!      &      + xz_Cloud2RainNH4SH( xz_MixRtAl(:,:,:) ) &
      &      )
    !
    do spc = 1, SpcNum
     xz_MixRtAl(:,:,spc) = xz_Boundary_Cyc_Sym(xz_MixRtAl(:,:,spc))
    end do
    

    !-------------------------------------------------------------
    ! ˰Ĵˡ
    !   <-->ѴԤ.
    !-------------------------------------------------------------
!    call MoistAdjustSvapPress( xz_ExnerNl, xz_PotTempAl, xz_MixRtAl(:,:,:) )
    call MoistAdjustSvapPress2( xz_ExnerNl, xz_PotTempAl, xz_MixRtAl(:,:,:) )
!    call MoistAdjustNH4SH( xz_ExnerNl, xz_PotTempAl, xz_MixRtAl(:,:,:) )
!    call MoistAdjustNH4SH2( xz_ExnerNl, xz_PotTempAl, xz_MixRtAl(:,:,:) )


    !-------------------------------------------------------------
    ! ȤΥѥ᥿ꥼ.
    !   <--> ѴԤ
    !-------------------------------------------------------------
   xz_PotTempAl =                                        &
      &   xz_PotTempAl                                    &
      & + DelTimeLFrog(t)                                 &
      &   * (                                             &
      &      + xz_LatentHeatRain2Gas(                   &
      &           xz_ExnerNl, xz_PotTempAl, xz_MixRtAl    &
      &          )                                        &
!      &      + xz_LatentHeatRain2Gas(                   &
!      &           xz_ExnerNl, xz_PotTempAl, xz_MixRtAl    &
!      &          )                                        &
      &      ) / ( xz_ExnerBasicZ * CpDry )
    !
    xz_PotTempAl = xz_Boundary_Cyc_Sym( xz_PotTempAl )
    
   xz_MixRtAl =                                                  &  
      &   xz_MixRtAl                                              &
      & + DelTimeLFrog(t)                                         &
      &   * (                                                     &
      &     + xz_Rain2Gas(xz_ExnerNl, xz_PotTempAl, xz_MixRtAl) &
!      &    + xz_Rain2GasNH4SH(xz_ExnerNl, xz_PotTempAl, xz_MixRtAl) &
      &    )      
    !
    do spc = 1, SpcNum
      xz_MixRtAl(:,:,spc) = xz_Boundary_Cyc_Sym(xz_MixRtAl(:,:,spc))
    end do


    !-------------------------------------------------------------
    ! Ĺ֥ƥåפǤ, ®٤ΰή, Ȼ, Ǵ, 
    !-------------------------------------------------------------
    pz_AccelVelXNl =                                        &
      & + pz_AdvVelX(pz_VelXNl, pz_VelXNl, xr_VelZNl)   &
      & + pz_TurbVelX(xz_KmBl,   pz_VelXBl, xr_VelZBl)  &
      & + pz_NumDiffVelX(pz_VelXBl)
    
    xr_AccelVelZNl =                                        &
      & + xr_AdvVelZ(xr_VelZNl, pz_VelXNl, xr_VelZNl)   &
      & + xr_Buoy(xz_PotTempNl)                         &    
      & + xr_MoistBuoy(xz_MixRtNl)                     &
      & + xr_TurbVelZ(xz_KmBl,   pz_VelXBl, xr_VelZBl)  &
      & + xr_NumDiffVelZ(xr_VelZBl)                        


    !-------------------------------------------------------------
    ! û֥ƥåפνͺ
    !-------------------------------------------------------------
    pz_VelXNs  = pz_VelXBl
    xr_VelZNs  = xr_VelZBl
    xz_ExnerNs = xz_ExnerBl
    
    !-------------------------------------------------------------
    ! û֥ƥåפʬ. 顼ˡ
    !-------------------------------------------------------------
    Eular: do tau = 1, NstepEular(t)

      !-------------------------------------------------------------
      ! ® u η׻
      !-------------------------------------------------------------
      pz_VelXAs = &
        & pz_VelXNs                                          &
        &  + DelTimeEular                                    &
        &    * (                                             &
        &     - pz_GradPi(xz_ExnerNs, pz_VelXNs, xr_VelZNs)  &
        &     + pz_AccelVelXNl                                   &
!        &     + pz_MFluxSfc(pz_VelXNs)                       &
        &     )
      pz_VelXAs = pz_Boundary_Cyc_Sym(pz_VelXAs)

      !-------------------------------------------------------------
      ! ʡؿη׻
      !-------------------------------------------------------------
      xz_ExnerAs = xz_Exner( &
        & xr_AccelVelZNl,     &
        & pz_VelXNs,      &
        & pz_VelXAs,      &
        & xr_VelZNs,      &
        & xz_ExnerNs)
      xz_ExnerAs = xz_Boundary_Cyc_Sym(xz_ExnerAs)

      !-------------------------------------------------------------
      ! ® w η׻
      !-------------------------------------------------------------
      xr_VelZAs =                                                    &
        & xr_VelZNs                                                  &
        &  + DelTimeEular                                            &
        &    * (                                                     &
        &     - xr_GradPi(xz_ExnerAs,xz_ExnerNs,pz_VelXNs,xr_VelZNs) &
        &     + xr_AccelVelZNl                                           &
        &     )
      xr_VelZAs = xr_Boundary_Cyc_AntiSym(xr_VelZAs)
      
      !-------------------------------------------------------------
      ! û֥ƥåפΥ롼פ󤹤ν
      !-------------------------------------------------------------
      xz_ExnerNs  = xz_ExnerAs
      pz_VelXNs   = pz_VelXAs
      xr_VelZNs   = xr_VelZAs

    end do Eular
    
    !----------------------------------------------------------------
    ! ǽŪû֥ƥåפǤͤĹ֥ƥåפǤͤȤߤʤ
    !----------------------------------------------------------------
    xz_ExnerAl  = xz_ExnerAs
    pz_VelXAl   = pz_VelXAs
    xr_VelZAl   = xr_VelZAs

    !-------------------------------------------------------------
    ! ݥ
    !-------------------------------------------------------------
    xz_ExnerAs   = xz_ExnerAs   - DelTimeLFrog(t) * xz_DampSponge_xz(xz_ExnerBl)
    pz_VelXAs    = pz_VelXAs    - DelTimeLFrog(t) * pz_DampSponge_pz(pz_VelXBl )
    xr_VelZAs    = xr_VelZAs    - DelTimeLFrog(t) * xr_DampSponge_xr(xr_VelZBl )
    xz_PotTempAl = xz_PotTempAl - DelTimeLFrog(t) * xz_DampSponge_xz(xz_PotTempBl)
        

    !----------------------------------------------------------------
    ! Ĺ֥ƥåפΥ롼פ󤹤ν
    !----------------------------------------------------------------
    xz_PotTempBl = xz_PotTempNl
    xz_MixRtBl   = xz_MixRtNl
    xz_ExnerBl   = xz_ExnerNl
    pz_VelXBl    = pz_VelXNl
    xr_VelZBl    = xr_VelZNl
    xz_KmBl      = xz_KmNl
    xz_KhBl      = xz_KhNl

    xz_PotTempNl = xz_PotTempAl
    xz_MixRtNl   = xz_MixRtAl
    xz_ExnerNl   = xz_ExnerAl
    pz_VelXNl    = pz_VelXAl
    xr_VelZNl    = xr_VelZAl
    xz_KmNl      = xz_KmAl
    xz_KhNl      = xz_KhAl
    
    !----------------------------------------------------------------
    ! ե
    !----------------------------------------------------------------
    if ( mod( Time, TimeDisp ) == 0 ) then

      ! CFL Υå
      call CFLCheckTimeLongVelX( pz_VelXNl )
      call CFLCheckTimeLongVelZ( xr_VelZNl )

      !ҥȥե
      call HistoryFile_Output(  &
        &  Time,                &
        &  xz_PotTempNl,        &
        &  xz_ExnerNl,          &
        &  pz_VelXNl,           &
        &  xr_VelZNl,           &
        &  xz_MixRtNl,          &
        &  xz_KmNl              )
      call HistoryFile_OutputAnal(  &
        &  xz_PotTempNl,            &
        &  xz_ExnerNl,              &
        &  xz_MixRtNl               )
    end if
    
  end do LFrog

  !----------------------------------------------------------------
  ! ϥեΥ
  !----------------------------------------------------------------
  call HistoryFile_Close

  !----------------------------------------------------------------
  ! ꥹȥեκ
  !----------------------------------------------------------------
!  call ReStartFile_Open( )
!  call ReStartFile_OutPut(                       &
!    & Time,                                      &
!    & pz_VelXBl,    xr_VelZBl,    xz_ExnerBl,    &
!    & xz_PotTempBl, xz_KmBl,      xz_MixRtBl     )
!  call ReStartFile_OutPut(                       &
!    & Time,                                      &
!    & pz_VelXNl,    xr_VelZNl,    xz_ExnerNl,    &
!    & xz_PotTempNl, xz_KmNl,      xz_MixRtNl     )
!  call ReStartFile_Close
  
contains

  subroutine ArareAlloc
    !
    !Ȥ, , ͤȤƥ.
    !

    !ۤηػ
    implicit none

    !
    allocate(                                                   &
      & pz_VelXBl(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & pz_VelXNl(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & pz_VelXAl(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & pz_VelXNs(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & pz_VelXAs(DimXMin:DimXMax, DimZMin:DimZMax),           &
!
      & xr_VelZBl(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & xr_VelZNl(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & xr_VelZAl(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & xr_VelZNs(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & xr_VelZAs(DimXMin:DimXMax, DimZMin:DimZMax),           &
!
      & xz_ExnerBl(DimXMin:DimXMax, DimZMin:DimZMax),          &
      & xz_ExnerNl(DimXMin:DimXMax, DimZMin:DimZMax),          &
      & xz_ExnerAl(DimXMin:DimXMax, DimZMin:DimZMax),          &
      & xz_ExnerNs(DimXMin:DimXMax, DimZMin:DimZMax),          &
      & xz_ExnerAs(DimXMin:DimXMax, DimZMin:DimZMax),          &
!
      & xz_PotTempBl(DimXMin:DimXMax, DimZMin:DimZMax),        &
      & xz_PotTempNl(DimXMin:DimXMax, DimZMin:DimZMax),        &
      & xz_PotTempAl(DimXMin:DimXMax, DimZMin:DimZMax),        &
!
      & xz_KmBl(DimXMin:DimXMax, DimZMin:DimZMax),             &
      & xz_KmNl(DimXMin:DimXMax, DimZMin:DimZMax),             &
      & xz_KmAl(DimXMin:DimXMax, DimZMin:DimZMax),             &
!
      & xz_KhBl(DimXMin:DimXMax, DimZMin:DimZMax),             &
      & xz_KhNl(DimXMin:DimXMax, DimZMin:DimZMax),             &
      & xz_KhAl(DimXMin:DimXMax, DimZMin:DimZMax),             &
!
      & xz_MixRtBl(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum), &
      & xz_MixRtNl(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum), &
      & xz_MixRtAl(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum), &
!
      & pz_AccelVelXNl(DimXMin:DimXMax, DimZMin:DimZMax),        &
      & xr_AccelVelZNl(DimXMin:DimXMax, DimZMin:DimZMax),        & 
!
      & DelTimeLFrog(NstepLong), NStepEular(NStepLong)               ) 

    pz_VelXNs = 0.0d0;     pz_VelXAs = 0.0d0    
    xr_VelZNs = 0.0d0;     xr_VelZAs = 0.0d0
    xz_ExnerNs = 0.0d0;    xz_ExnerAs = 0.0d0

    pz_VelXBl = 0.0d0;     pz_VelXNl = 0.0d0;     pz_VelXAl = 0.0d0
    xr_VelZBl = 0.0d0;     xr_VelZNl = 0.0d0;     xr_VelZAl = 0.0d0
    xz_ExnerBl = 0.0d0;    xz_ExnerNl = 0.0d0;    xz_ExnerAl = 0.0d0
    xz_KmBl = 0.0d0;       xz_KmNl = 0.0d0;       xz_KmAl = 0.0d0
    xz_KhBl = 0.0d0;       xz_KhNl = 0.0d0;       xz_KhAl = 0.0d0
    xz_PotTempBl = 0.0d0;  xz_PotTempNl = 0.0d0;  xz_PotTempAl = 0.0d0
    xz_MixRtBl = 0.0d0;    xz_MixRtNl = 0.0d0;    xz_MixRtAl = 0.0d0

    pz_AccelVelXNl = 0.0d0
    xr_AccelVelZNl = 0.0d0

    DelTimeEular = 0.0d0
    DelTimeLFrog = 0.0d0; 
    NStepEular = 0.0d0
    NstepLFrog = 0.0d0

  end subroutine ArareAlloc
      

end program arare
