!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005. All rights reserved.
!---------------------------------------------------------------------

!= Subroutine ECCM
!
!   * Developer: SUGIYAMA Ko-ichiro 
!   * Version: $Id: eccm.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview 
!
!ǮŪ˾徺뵤βٸΨ׻, ſ尵ʿդ鰵Ϥ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * Ǯ, ʿʬ̤
!  * 顼٤­ʤΤ, 󥲥å. 
!
!== Future Plans
!

module ECCM

  !⥸塼ɤ߹
  use gridset,  only: DimZMin,       &!  Z β
    &                 DimZMax,       &!  Z ξ 
    &                 RegZMin,       &!
    &                 SpcNum,        &!
    &                 DelZ            !
  use basicset,only:  MolWtDry,      &!
    &                 MolWtWet,      &!
    &                 CpDryMol,      &!
    &                 SpcWetID,      &!
    &                 SpcWetSymbol,  &!
    &                 TempSfc,       &!
    &                 PressSfc,      &!
    &                 Grav            !
  use chemcalc, only: SvapPress,     &!
    &                 LatentHeatPerMol, &!
    &                 ReactHeatNH4SHPerMol
  use ChemData, only: GasRUniv,      &!
    &                 ChemData_OneSpcID
  use MoistFunc,only: DelMolFrNH4SH 

  !ۤηػ
  implicit none

  !°λ
  private

  !ؿθ
  public ECCM_Init
  public ECCM_Temp_Press
  public ECCM_MolFr

  !ѿ
  integer     :: LoopNum = 0
  integer     :: GasNum(10) = 0
  integer     :: CloudNum(10) = 0
  integer     :: NH3Num = 0
  integer     :: H2SNum = 0
  
  save LoopNum, GasNum, CloudNum
  save NH3Num, H2SNum
  
contains


  subroutine ECCM_Init( )

    !ۤηػ
    implicit none

    !ѿ
    integer                  :: s
    integer                  :: n1

    !-----------------------------------------------------------
    ! γȵΤ ID Ȥ
    !-----------------------------------------------------------
    !
    LoopNum = 0

    !ؼ椫γΤ, źʬ̤ݴ.
    SelectCloud: do s = 1, SpcNum
      
      ! NH4SH ˤĤƤ̵
      if ( trim(SpcWetSymbol(s)) == 'NH4SH-s-Cloud' ) then 
        cycle SelectCloud
      end if

      !'Cloud' Ȥʸ󤬴ޤޤΤθĿ
      n1 = index(SpcWetSymbol(s), '-Cloud' )
      if (n1 /= 0) then
        LoopNum          = LoopNum + 1
        CloudNum(LoopNum)= s
        GasNum(LoopNum)  = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID(SpcWetSymbol(s)(1:n1-3) // '-g'))
      end if
    end do SelectCloud
    
    !-----------------------------------------------------------
    ! β˥, ӥ˥βǤ ID 
    !-----------------------------------------------------------
    NH3Num   = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('NH3-g'))
    H2SNum   = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('H2S-g'))

    !-----------------------------------------------------------
    ! ǧ
    !-----------------------------------------------------------
    if ( LoopNum == 0 ) then 
      write(*,*) "MoistAdjust: CloudNum = 0, please comment out of MoistAdjust"
      stop
    end if
    
    write(*,*) "ECCM_Init, LoopNum:      ", LoopNum
    write(*,*) "ECCM_Init, CloudNum:     ", CloudNum
    write(*,*) "ECCM_Init, GasNum:       ", GasNum    
    write(*,*) "ECCM_Init, NH3Num:       ", NH3Num
    write(*,*) "ECCM_Init, H2SNum:       ", H2SNum

  end subroutine ECCM_Init


!!!------------------------------------------------------------------------------!!!
  subroutine ECCM_Temp_Press( MolFrIni, z_Temp, z_Press )

    !ۤηػ
    implicit none
    
    real(8), intent(in) :: MolFrIni(1:SpcNum)
    real(8), intent(out):: z_Temp(DimZMin:DimZMax)
    real(8), intent(out):: z_Press(DimZMin:DimZMax)
    
    real(8)             :: z_MolFr(DimZMin:DimZMax, 0:SpcNum) 
                                                   !ʬΨ
    real(8)             :: z_DTempDZ(DimZMin:DimZMax) 
    real(8)             :: MolFr(0:SpcNum) 
    real(8)             :: z_MolWtMean(DimZMin:DimZMax) 
    integer             :: k

    real(8)             :: Temp1, Press1, MolWtMean1, DTempDZ1
    real(8)             :: Temp2, Press2, MolWtMean2, DTempDZ2
    real(8)             :: Temp3, Press3, MolWtMean3, DTempDZ3
    real(8)             :: Temp4, Press4, MolWtMean4, DTempDZ4
    
    
    !-------------------------------------------------------------
    ! ν
    !-------------------------------------------------------------
    !
    z_MolFr = 0.0d0
    z_MolFr(RegZMin, 1:SpcNum)   = MolFrIni(1:SpcNum) 
    z_MolFr(RegZMin, 0)          = 1.0d0 - sum(MolFrIni)
    z_MolFr(RegZMin-1, 1:SpcNum) = MolFrIni(1:SpcNum) 
    z_MolFr(RegZMin-1, 0)        = 1.0d0 - sum(MolFrIni)
    
    !ɽ̤Ǥβ(RegZMin ,  DelZ / 2 )
    z_Temp          = 0.0d0
    z_Temp(RegZMin) = TempSfc - Grav * MolWtDry / CpDryMol * DelZ * 5.0d-1
    
    !ɽ̤Ǥΰ(RegZMin ,  DelZ / 2 )
    z_Press           = 0.0d0
    z_Press(RegZMin)  = PressSfc *((TempSfc / z_Temp(RegZMin)) &
      &                             ** ( - CpDryMol /  GasRUniv ))
    
    !ʬ̤ν
    z_MolWtMean     = 0.0d0

    !-----------------------------------------------------------
    ! ǮΨ dT/dz η׻. 
    !-----------------------------------------------------------    
    do k = RegZMin, DimZMax-1
      
      !
      z_MolFr(k,:) = z_MolFr(k-1,:)
      
      !==============================================================
      !ǮΨ󥲥åˡѤƷ׻
      Temp1  = z_Temp(k)
      Press1 = z_Press(k)
      MolFr  = z_MolFr(k-1,:)
      call ECCM_DTempDZ( Temp1, Press1, z_MolFr(k,:), MolWtMean1, DTempDZ1 )
      
      Temp2  = Temp1 + DTempDZ1 * DelZ * 5.0d-1
      Press2 =                                               &
        & Press1 * ( ( Temp1 / Temp2 )                       &
        &      ** (Grav * MolWtMean1 / (GasRUniv * DTempDZ1) ) )
      call ECCM_DTempDZ( Temp2, Press2, MolFr, MolWtMean2, DTempDZ2 )

      Temp3  = Temp1 + DTempDZ2 * DelZ * 5.0d-1
      Press3 =                                               &
        & Press1 * ( ( Temp1 / Temp3 )                       &
        &      ** (Grav * MolWtMean2 / (GasRUniv * DTempDZ2) ) )
      call ECCM_DTempDZ( Temp3, Press3, MolFr, MolWtMean3, DTempDZ3 )
      
      Temp4  = Temp1 + DTempDZ3 * DelZ  
      Press4 =                                               &
        & Press1 * ( ( Temp1 / Temp4 )                       &
        &      ** (Grav * MolWtMean3 / (GasRUniv * DTempDZ3) ) )
      call ECCM_DTempDZ( Temp4, Press4, MolFr, MolWtMean4, DTempDZ4 )
      
      z_DTempDZ(k) = ( + DTempDZ1 + DTempDZ2 * 2.0d0           &
        &              + DTempDZ3 * 2.0d0 + DTempDZ4 ) / 6.0d0

      z_MolWtMean(k) = ( + MolWtMean1 + MolWtMean2 * 2.0d0           &
        &                + MolWtMean3 * 2.0d0 + MolWtMean4 ) / 6.0d0
      !==============================================================

      !٤׻
      z_Temp(k+1) = z_Temp(k) + z_DTempDz(k) * DelZ
      
      !Ϥſ尵ʿդ׻
      z_Press(k+1) =                                                  &
        &  z_Press(k) * ( ( z_Temp(k) / z_Temp(k+1))                  &
        &    ** (Grav * z_MolWtMean(k) / (GasRUniv * z_DTempDZ(k)) ) )

!      write(*,*) 'ECCM, MolFr:   ', k, z_MolFr(k,1:3)
!      write(*,*) 'ECCM, Temp:    ', k, z_Temp(k)
!      write(*,*) 'ECCM, Press:   ', k, z_Press(k)

!      write(*,*) 'ECCM, DTempDZ: ', k, z_DTempDZ(k)
!      write(*,*) 'ECCM, DTempDZ: ', k, DTempDZ1, DTempDZ2, DTempDZ3, DTempDZ4
      
      ! (DimZMax ǤͤĤ褦ˤ뤿)
      z_MolFr(k+1,:) = z_MolFr(k,:)
      z_MolFr(k+1,0) = 1.0d0 - sum( z_MolFr(k,1:SpcNum) )
      
    end do
    
  end subroutine ECCM_Temp_Press



!!!------------------------------------------------------------------------------!!!
  subroutine ECCM_MolFr( MolFrIni, Humidity, z_Temp, z_Press, z_MolFr )
    
    !ۤηػ
    implicit none
    
    real(8), intent(in):: MolFrIni(1:SpcNum)
    real(8), intent(in):: Humidity
    real(8), intent(in) :: z_Temp(DimZMin:DimZMax)
    real(8), intent(in) :: z_Press(DimZMin:DimZMax)
    real(8), intent(out):: z_MolFr(DimZMin:DimZMax, 1:SpcNum)
    
    real(8)             :: SatPress
    real(8)             :: DelMolFr
    integer             :: k, s
    

    !-----------------------------------------------------------
    ! ν
    !-----------------------------------------------------------
    !
    z_MolFr = 0.0d0
    z_MolFr(RegZMin, 1:SpcNum)   = MolFrIni(1:SpcNum) 
    z_MolFr(RegZMin-1, 1:SpcNum) = MolFrIni(1:SpcNum) 
    

    !-----------------------------------------------------------
    ! ǮΨ dT/dz η׻. 
    !-----------------------------------------------------------
    do k = RegZMin, DimZMax
      
      z_MolFr(k,:) = z_MolFr(k-1,:) 
      
      !------------------------------------------------------------
      !NH4SH ʳβؼʿվ
      !------------------------------------------------------------
      do s = 1, LoopNum      
        !˰¾
        SatPress = SvapPress( SpcWetID(CloudNum(s)), z_Temp(k) )
        
        !˰¾ȰϤ׻
        !  ΥƥåפǤͤ礭ʤʤ褦ˤ
        z_MolFr(k,GasNum(s)) = &
          & min( SatPress * Humidity / z_Press(k), z_MolFr(k-1,GasNum(s)) )
      end do

      !------------------------------------------------------------
      !NH4SH ʿվ
      !------------------------------------------------------------
      if ( NH3Num /= 0 ) then 
        
        DelMolFr = DelMolFrNH4SH(z_Temp(k), z_Press(k),        &
          &                      z_MolFr(k,NH3Num), z_MolFr(k,H2SNum) )
        z_MolFr(k,NH3Num) = z_MolFr(k,NH3Num) - DelMolFr
        z_MolFr(k,H2SNum) = z_MolFr(k,H2SNum) - DelMolFr
      end if

    end do
  end subroutine ECCM_MolFr



  subroutine ECCM_DTempDZ( Temp, Press, MolFr, MolWtMean, DTempDZ )
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in) :: Temp
    real(8), intent(in) :: Press
    real(8), intent(inout) :: MolFr(0:SpcNum)    !ʬΨ
    real(8), intent(out):: MolWtMean
    real(8), intent(out):: DTempDZ
    real(8)             :: MolWt(0:SpcNum)
    real(8)             :: ReactHeat
    real(8)             :: Heat(SpcNum)
    real(8)             :: DelMolFr
    real(8)             :: SatPress
    real(8)             :: VapPress
    real(8)             :: A, B
    integer             :: s

    !
    DTempDZ      = 0.0d0
    ReactHeat    = 0.0d0
    Heat         = 0.0d0
    DelMolFr     = 0.0d0
    SatPress     = 0.0d0
    VapPress     = 0.0d0
    MolWt(0)        = MolWtDry
    MolWt(1:SpcNum) = MolWtWet(1:SpcNum)

    !------------------------------------------------------------
    !NH4SH ʳβؼʿվ
    !------------------------------------------------------------
    do s = 1, LoopNum      
      
      !˰¾
      SatPress = SvapPress( SpcWetID(CloudNum(s)), Temp )
      
      !Ǯ. 
      Heat(GasNum(s)) = &
        & LatentHeatPerMol( SpcWetID(CloudNum(s)), Temp )
        
      !ΥʬΨѤƸߤξ׻
      VapPress = MolFr(GasNum(s)) * Press
      
      !˰¾ŷ̵ͭ
      if ( VapPress < SatPress ) then         
        !Ѳʤ
        MolFr(GasNum(s)) = MolFr(GasNum(s))
        
        !ŷ뤷ƤʤΤǮʤ.
        Heat(GasNum(s)) = 0.0d0          
      else      
        !˰¾ȰϤ鸽ߤΥ׻
        MolFr(GasNum(s)) = max(SatPress / Press, 1.0d-16)
      end if
    end do

    !------------------------------------------------------------
    !NH4SH ʿվ
    !------------------------------------------------------------
    if ( NH3Num /= 0 ) then 
      
      DelMolFr = DelMolFrNH4SH(Temp, Press,                   &
        &                      MolFr(NH3Num), MolFr(H2SNum) )
      MolFr(NH3Num) = MolFr(NH3Num) - DelMolFr
      MolFr(H2SNum) = MolFr(H2SNum) - DelMolFr
      
      ReactHeat = ReactHeatNH4SHPerMol * DelMolFr
    end if

    !------------------------------------------------------------
    !ٸۤ׻
    !------------------------------------------------------------
    !
    MolFr(0) = 1.0d0 - sum( MolFr(1:SpcNum) )

    !ʬ
    MolWtMean = dot_product( MolWt, MolFr )

    !.  Temp(i) ɾ
    A = dot_product( Heat(1:SpcNum), MolFr(1:SpcNum)) &
      &  / ( GasRUniv * Temp )
    B = dot_product(( Heat(1:SpcNum) ** 2.0d0), MolFr(1:SpcNum)) &
      &  / ( CpDryMol * GasRUniv * ( Temp ** 2.0d0 ) )

    !ǮٸΨ
    DTempDZ = - Grav * MolWtMean * ( 1.0d0 + A )   &
      &         / ( CpDryMol * ( 1.0d0 + B ) )     &
      &       + ReactHeat / ( CpDryMol * DelZ )
    
  end subroutine ECCM_DTempDZ
  
end module ECCM
