!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Subroutine FillNegative
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: fillnegative.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview
!
!α̤ʤɤ᤹뤿Υ롼
!  * Ȥʤäˤ, Ϥ 8 ʻͤäƷ᤹.
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!  *  deepconv  QFILL.f 
!
!== Future Plans
!
!

subroutine FillNegative( xz_DensBasicZ, xz_Var )
  !
  !α̤ʤɤ᤹뤿Υ롼
  !  * Ȥʤäˤ, Ϥ 8 ʻͤäƷ᤹.
  ! 

  !⥸塼ɤ߹
  use gridset,    only: DimXMin,  &!  X β
    &                   DimXMax,  &!  X ξ
    &                   DimZMin,  &!  Z β
    &                   DimZMax    !  Z ξ
!  use basicset, only: xz_DensBasicZ
  
  implicit none

  real(8), intent(inout) :: xz_Var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)    :: xz_DensBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)                :: xz_VarFill(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)                :: xz_DQFILL(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)                :: xz_QSUMPN(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), parameter     :: EPS = 1.0d-60  !Ǥγ껻ɤ
  integer                :: i, k

  !
  xz_QSUMPN = 0.0d0
  xz_DQFILL = 0.0d0


  do k = DimZMin+2, DimZMax-2
    do i = DimXMin+2, DimXMax-2
      xz_QSUMPN(i,k) = 1.0d0 / &
        &  ( (   MAX( 0.0d0, xz_Var(i-1,k) )* xz_DensBasicZ(i-1,k) &
        &      + MAX( 0.0d0, xz_Var(i+1,k) )* xz_DensBasicZ(i+1,k) &
        &      + MAX( 0.0d0, xz_Var(i,k-1) )* xz_DensBasicZ(i,k-1) &
        &      + MAX( 0.0d0, xz_Var(i,k+1) )* xz_DensBasicZ(i,k+1) &
        &     ) * 0.75d0   &
        &  + (   MAX( 0.0d0, xz_Var(i-2,k) )* xz_DensBasicZ(i-2,k) &
        &      + MAX( 0.0d0, xz_Var(i+2,k) )* xz_DensBasicZ(i+2,k) &
        &      + MAX( 0.0d0, xz_Var(i,k-2) )* xz_DensBasicZ(i,k-2) &
        &      + MAX( 0.0d0, xz_Var(i,k+2) )* xz_DensBasicZ(i,k+2) &
        &     ) * 0.25d0 + EPS ) 
    end do
  end do

  do k = DimZMin+2, DimZMax-2
    do i = DimXMin+2, DimXMax-2
      xz_DQFILL(i,k) =         &
        &  - MIN( 0.0d0, xz_Var(i,k) ) &
        &  + MAX( 0.0d0, xz_Var(i,k) ) &
        &    * ( ( MIN( 0.0d0, xz_Var(i-1,k) ) * xz_QSUMPN(i-1,k) &
        &          * xz_DensBasicZ(i-1,k)     &
        &        + MIN( 0.0d0, xz_Var(i+1,k) ) * xz_QSUMPN(i+1,k) &
        &          * xz_DensBasicZ(i+1,k)     &
        &        + MIN( 0.0d0, xz_Var(i,k-1) ) * xz_QSUMPN(i,k-1) &
        &          * xz_DensBasicZ(i,k-1)   &
        &        + MIN( 0.0d0, xz_Var(i,k+1) ) * xz_QSUMPN(i,k+1) &
        &          * xz_DensBasicZ(i,k+1)   & 
        &         ) * 0.75d0                    &
        &      + ( MIN( 0.0d0, xz_Var(i-2,k) ) * xz_QSUMPN(i-2,k) &
        &           * xz_DensBasicZ(i-2,k)    &
        &        + MIN( 0.0d0, xz_Var(i+2,k) ) * xz_QSUMPN(i+2,k) &
        &           * xz_DensBasicZ(i+2,k)    &
        &        + MIN( 0.0d0, xz_Var(i,k-2) ) * xz_QSUMPN(i,k-2) &
        &           * xz_DensBasicZ(i,k-2)  &
        &        + MIN( 0.0d0, xz_Var(i,k+2) ) * xz_QSUMPN(i,k+2) &
        &           * xz_DensBasicZ(i,k+2)  &
        &        ) * 0.25d0 &
        &      )
    end do
  end do

  xz_VarFill = xz_Var + xz_DQFILL

  !
  xz_Var = xz_VarFill


end subroutine FillNegative
